#ifndef FORMATIONTYPES_H
#define FORMATIONTYPES_H

typedef int Pnum;

#define MAX_PLAYERS 25
#define Pnum_Unknown  0
#define Formation_Unknown NULL

// Player Type
enum Ptype{
  PT_None,
  PT_Goaltender,
  PT_Sweeper,
  PT_Defender,
  PT_Midfielder,
  PT_Forward
};

// Player Side
enum Pside{
  PS_None,
  PS_Left,
  PS_Center,
  PS_Right
};

// Unit Type
enum Utype{
  UT_Defense,
  UT_Midfield,
  UT_Forward,
  UT_Left,
  UT_Center,
  UT_Right,
  UT_None
};

// Formation Type
enum Ftype{
  FT_None,
  FT_433,
  FT_442,
  FT_352,
  FT_72,
  FT_334,
  FT_244,
  FT_532,
  FT_right,
  FT_left
};

// Field Side
enum Fside{ 
  FS_Right,
  FS_Left
};


//					4-3-3 Formation 
#define f433_GOALIE           1
#define f433_SWEEPER         (f433_GOALIE         +1)
#define f433_RIGHT_DEFENSE   (f433_SWEEPER        +1)
#define f433_CENTER_DEFENSE  (f433_RIGHT_DEFENSE  +1)
#define f433_LEFT_DEFENSE    (f433_CENTER_DEFENSE +1)
#define f433_RIGHT_MIDFIELD  (f433_LEFT_DEFENSE   +1)
#define f433_CENTER_MIDFIELD (f433_RIGHT_MIDFIELD +1) 
#define f433_LEFT_MIDFIELD   (f433_CENTER_MIDFIELD+1) 
#define f433_RIGHT_WING      (f433_LEFT_MIDFIELD  +1) 
#define f433_CENTER_FORWARD  (f433_RIGHT_WING     +1) 
#define f433_LEFT_WING       (f433_CENTER_FORWARD +1) 

//					4-4-2 Formation 

#define f442_GOALIE                     1
#define f442_SWEEPER                   (f442_GOALIE         +1)
#define f442_RIGHT_DEFENSE             (f442_SWEEPER        +1)
#define f442_CENTER_DEFENSE            (f442_RIGHT_DEFENSE  +1)
#define f442_LEFT_DEFENSE              (f442_CENTER_DEFENSE +1)
#define f442_RIGHT_MIDFIELD            (f442_LEFT_DEFENSE   +1)
#define f442_DEFENSIVE_CENTER_MIDFIELD (f442_RIGHT_MIDFIELD +1) 
#define f442_OFFENSIVE_CENTER_MIDFIELD (f442_DEFENSIVE_CENTER_MIDFIELD +1) 
#define f442_LEFT_MIDFIELD             (f442_OFFENSIVE_CENTER_MIDFIELD+1) 
#define f442_RIGHT_WING                (f442_LEFT_MIDFIELD  +1) 
#define f442_LEFT_WING                 (f442_RIGHT_WING +1) 


#endif  // FORMATIONTYPES_H
