#include "stdafx.h"
#include "Skills.h"
#include "LogManager.h"
#include "Config.h"
#include "WorldObjects.h"

extern CConfig *cfg;
extern FILE *m_ff;

void CBasicSkills::Dash(CLocalAgent *pa, double power)
{
    CGameCommand *pGameCommand = new CGameCommand();
    
    pGameCommand->Dash(power);
    pa->actionseq->AddGameCommand(pGameCommand);
}

void CBasicSkills::Turn(CLocalAgent *pa, double moment)
{
    CGameCommand *pGameCommand = new CGameCommand();
    
    pGameCommand->Turn(moment);
    pa->actionseq->AddGameCommand(pGameCommand);

    // QUICK FIX NA OTACANIE - ZRUSIT KED BUDE DOBRY WORLDMODEL (SO ZAPOCITANIM POSLEDNEJ HRACOVEJ AKCIE)
    pa->lastturn = moment;
}

void CBasicSkills::Kick(CLocalAgent *pa, double power, double dir)
{
    CGameCommand *pGameCommand = new CGameCommand();
    
    pGameCommand->Kick(power, dir);
    pa->actionseq->AddGameCommand(pGameCommand);
}

void CBasicSkills::TurnNeck(CLocalAgent *pa, double angle)
{
    CGameCommand *pGameCommand = new CGameCommand();
    
    pGameCommand->TurnNeck(angle);
    pa->actionseq->AddGameCommand(pGameCommand);
}

void CBasicSkills::Move(CLocalAgent *pa, double x, double y)
{
    CGameCommand *pGameCommand = new CGameCommand();
    
    pGameCommand->Move(x, y);
    pa->actionseq->AddGameCommand(pGameCommand);
}

void CBasicSkills::Catch(CLocalAgent *pa, double dir)
{
    CGameCommand *pGameCommand = new CGameCommand();
    
    pGameCommand->Catch(dir);
    pa->actionseq->AddGameCommand(pGameCommand);
}

void CBasicSkills::Say(CLocalAgent *pa, string message)
{
    CGameCommand *pGameCommand = new CGameCommand();
    
    pGameCommand->Say(message);
    pa->actionseq->AddGameCommand(pGameCommand);
}

void CBasicSkills::ChangeView(CLocalAgent *pa, EViewWidth width, EViewQuality quality)
{
    CGameCommand *pGameCommand = new CGameCommand();
    
    pGameCommand->ChangeView(width, quality);
    pa->actionseq->AddGameCommand(pGameCommand);
}



void CBasicSkills::Turn2(CLocalAgent *pa, double angle)
{
    double moment = TurnReal2Wanted(pa, angle);
    if ((moment > 180) || (moment < -180))
    {
        LOGMSG(1, "ERROR Skill 'Turn2': greater angle than possible (%lf) (speed %lf)", moment, pa->GetSpeed().GetDistance());
//        return;
        moment > 180 ? moment = 180 : moment = -180;
    }
    Turn(pa, moment);
}

double CBasicSkills::TurnWanted2Real(CLocalAgent *pa, double angle)
{
    double dPlayerSpeed = pa->GetSpeed().GetDistance();
    return angle / (1.0 + cfg->inertia_moment * dPlayerSpeed);
}

double CBasicSkills::TurnReal2Wanted(CLocalAgent *pa, double moment)
{
    double dPlayerSpeed = pa->GetSpeed().GetDistance();
    return moment * (1.0 + cfg->inertia_moment * dPlayerSpeed);
}



void CBasicSkills::Kick2(CLocalAgent *pa, double power, double dir)
{
    // treba dat pozor aby sme nekopli do seba (prip. do ineho hraca???)

    // treba zapocitat rychlost lopty + natocenie
    CBall *pBall = pa->GetWorldModel()->GetBall();
    CDiffuse2DVector vball = Rot(pBall->GetPosition() - pa->GetPosition(), DegToRad(-pa->GetDirection()));
    double dist_ball = vball.GetDistance();
    double dir_diff = fabs(vball.GetAngle());
    double factor = cfg->kick_power_rate * (1.0 - 0.25 * dir_diff / 180.0 - 0.25 * (dist_ball - cfg->player_size - cfg->ball_size) / cfg->kickable_margin);

    C2DVector vkick;
    vkick.SetAngleDistance(DegToRad(dir), power * factor);
    vkick -= pBall->GetSpeed();
    double power2 = vkick.GetDistance() / factor;
    double dir2 = RadToDeg(vkick.GetAngle());

    if (power2 > 100) power2 = 100;

    Kick(pa, power2, dir2);

}




void CBasicSkills::TurnTo(CLocalAgent *pa, C2DVector pos)
{
    C2DVector topos = Rot(pos - (C2DVector)pa->GetPosition(), DegToRad(-pa->GetDirection()));
    double ang = RadToDeg(topos.GetAngle());
    Turn2(pa, ang);
}


void CBasicSkills::TurnNeckTo(CLocalAgent *pa, C2DVector pos)
{
    C2DVector necktopos = Rot(pos - (C2DVector)pa->GetPosition(), DegToRad(pa->GetNeckDirection()));
    double neckang = RadToDeg(necktopos.GetAngle());
    TurnNeck(pa, neckang);
}

void CBasicSkills::TurnNeckToBall(CLocalAgent *pa)
{
    CBall *pBall = pa->GetWorldModel()->GetBall();
    CDiffuse2DVector vball = pBall->GetPosition() - pa->GetPosition();
    double necktoball = RadToDeg(vball.GetAngle() - pa->GetNeckDirection());
    TurnNeck(pa, necktoball);
}

void CBasicSkills::TurnNeckStraight(CLocalAgent *pa)
{
    double neckang =  pa->GetDirection() - pa->GetNeckDirection();
    if ((neckang < -1.0) || (neckang > 1.0)) TurnNeck(pa, neckang);
}


//! pozor - GoTo ide teraz iba na loptu, ak chceme ist inde, treba zrusit minus v -pa->GetDirection()
void CBasicSkills::GoTo(CLocalAgent *pa, C2DVector pos, double spd)
{
    C2DVector topos = Rot(pos - (C2DVector)pa->GetPosition(), DegToRad(-pa->GetDirection()));
    double ang = RadToDeg(topos.GetAngle());

    // zistujeme, ci je v ceste nejaky hrac
    CAgent *paiw = PlayerInWay(pa, ang);
    if (paiw) {
        // tu sa riesi vyhybanie sa hracovi
        C2DVector toplr = Rot(paiw->GetPosition() - pa->GetPosition(), DegToRad(-pa->GetDirection()));
        double pldist = toplr.GetDistance();
        double pldir = RadToDeg(toplr.GetAngle());
        fprintf(m_ff, "player in way - dist %lf, dir %lf\n",pldist,pldir);

        ang -= pldir;
    }

    double mindir = 5.0; // aby sme sa stale netocili
    if ((ang > -mindir) && (ang < mindir)) 
    {
        if (topos.GetDistance() > cfg->kickable_area) 
        {
            Dash(pa, spd);
        } 
        else 
        {
            LOGMSG(1, "ERROR Skill 'GoTo': already there.\n");
            return;
        }
    }
    else 
    {
        Turn2(pa, ang);
    }
}

void CBasicSkills::KickTo(CLocalAgent *pa, C2DVector pos, double pow)
{
    C2DVector topos = Rot(pos - (C2DVector)pa->GetPosition(), DegToRad(-pa->GetDirection()));
    double ang = RadToDeg(topos.GetAngle());
    Kick2(pa, pow, ang);
}


void CBasicSkills::DribbleTo(CLocalAgent *pa, C2DVector pos, double spd, double safe)
{
    // Dorobit vyhybanie sa ostatnym hracom!

    if (BallKickable(pa)) {
        TurnNeckTo(pa, pos);
        KickTo(pa, pos, spd);

    } else {
        TurnNeckStraight(pa);
        C2DVector ballpos = pa->GetWorldModel()->GetBall()->GetPosition();
        double pow = spd;   //taka sila, aby zastal tesne pred loptou
        GoTo(pa, ballpos, pow);
    }

}



bool CBasicSkills::BallKickable(CLocalAgent *pa)
{
    CBall *pBall = pa->GetWorldModel()->GetBall();
    CDiffuse2DVector vball = Rot(pBall->GetPosition() - pa->GetPosition(), DegToRad(-pa->GetDirection()));
    double disttoball = vball.GetDistance();
    double diffuball = vball.GetDiffusion();
    double dist = cfg->kickable_area - disttoball;
    /*
    if (dist < -diffuball) return 0;
    if (dist >= diffuball) return 1;
    return fabs(dist)/2.0;
    */
    if (dist < 0) return false;
    return true;
}

double CBasicSkills::NearGoal(CLocalAgent *pa, C2DVector goalpos)
{
    CDiffuse2DVector goal(goalpos, 0);
    CDiffuse2DVector vgoal = goal - pa->GetPosition();
    double disttogoal = vgoal.GetDistance();
    double diffugoal = vgoal.GetDiffusion();
    double dist = 20 - disttogoal; // FIXME - nie 20, ale nejako vyratat odkial uz mozem strielat do brany
    if (dist < -diffugoal) return 0;
    if (dist >= diffugoal) return 1;
    return fabs(dist)/2.0;
}


//! Vrati minimalny uhol, v ktorom moze byt relativne ku mne iny hrac aby som donho nenarazil
double CBasicSkills::MinimalDirection(double dist)
{
    return RadToDeg(asin(cfg->player_size / (dist + cfg->player_size)));
}


CAgent *CBasicSkills::PlayerInWay(CLocalAgent *pa, double dir)
{
    CWorldModel *pwm = pa->GetWorldModel();
    Agents *pia = pwm->GetIdentifiedAgents();
    Agents *pua = pwm->GetUnidentifiedAgents();

    int i;
    C2DVector toplr, toplr2;
    double pldir;
    double pldist, pldist2;
    double mindir;
    CAgent *pnow = NULL;
    CAgent *pret = NULL;

    fprintf(m_ff, "search 4 player in way (see total %d players)\n", pia->size()+pua->size());


    // hladame medzi identifikovanymi hracmi
	for(i=0; i < pia->size(); i++)
	{
        pnow = pia->at(i);
        // vektor na hraca
        toplr = Rot(pnow->GetPosition() - pa->GetPosition(), DegToRad(-pa->GetDirection()));
        pldir = RadToDeg(toplr.GetAngle());
        pldist = toplr.GetDistance();
        mindir = MinimalDirection(pldist);
        if ((pldir >= -mindir) && (pldir <= mindir)) {
            if (pret) {
                toplr2 = Rot(pret->GetPosition() - pa->GetPosition(), DegToRad(-pa->GetDirection()));
                pldist2 = toplr2.GetDistance();
                // vratime toho co je blizsie
                if( pldist < pldist2) pret = pnow;
            }
        }
    }

    // hladame medzi neidentifikovanymi hracmi
    for(i=0;i<pua->size();i++)
	{
        pnow = pua->at(i);
        // vektor na hraca
        toplr = Rot(pnow->GetPosition() - pa->GetPosition(), DegToRad(-pa->GetDirection()));
        pldir = RadToDeg(toplr.GetAngle());
        pldist = toplr.GetDistance();
        mindir = MinimalDirection(pldist);
        if ((pldir >= -mindir) && (pldir <= mindir)) {
            if (pret) {
                toplr2 = Rot(pret->GetPosition() - pa->GetPosition(), DegToRad(-pa->GetDirection()));
                pldist2 = toplr2.GetDistance();
                // vratime toho co je blizsie
                if( pldist < pldist2) pret = pnow;
            }
        }
    }

    return pret;
}

/*
double CBasicSkills::NearestOpponentToBall(CLocalAgent *pa)
{


    return 0;
}
*/


