#ifndef SKILLS_H
#define SKILLS_H

#include "GameCommand.h"
#include "WorldGeometry.h"

class CLocalAgent;           // aby sme sa vyhli rekurzivnemu includovaniu
class CAgent;
class CBall;

class CBasicSkills
{
protected:
    double MinimalDirection(double dist);

public:
    //! priam az elementary skills
    void Dash      (CLocalAgent *pa, double power);
    void Turn      (CLocalAgent *pa, double moment);
    void Kick      (CLocalAgent *pa, double power, double dir);
    void TurnNeck  (CLocalAgent *pa, double angle);
    void Move      (CLocalAgent *pa, double x, double y);
    void Catch     (CLocalAgent *pa, double dir);
    void Say       (CLocalAgent *pa, string message);
    void ChangeView(CLocalAgent *pa, EViewWidth width, EViewQuality quality);

public:
    //! zapocitanie rychlosti hraca...(prip. lopty)
    void Turn2(CLocalAgent *pa, double angle);
    double TurnWanted2Real(CLocalAgent *pa, double angle);
    double TurnReal2Wanted(CLocalAgent *pa, double moment);
    void Kick2(CLocalAgent *pa, double power, double dir);

public:
    //! low level skills
    void TurnTo(CLocalAgent *pa, C2DVector pos);

    void TurnNeckTo(CLocalAgent *pa, C2DVector pos);
    void TurnNeckToBall(CLocalAgent *pa);
    void TurnNeckStraight(CLocalAgent *pa);

    void GoTo(CLocalAgent *pa, C2DVector pos, double spd);
    void KickTo(CLocalAgent *pa, C2DVector pos, double pow);
    void DribbleTo(CLocalAgent *pa, C2DVector pos, double spd, double safe);

public:
    //! jednoduche ohodnocovacie skills
    bool BallKickable(CLocalAgent *pa);
    double NearGoal(CLocalAgent *pa, C2DVector goalpos);
    CAgent *PlayerInWay(CLocalAgent *pa, double dir);
//    double NearestOpponentToBall(CLocalAgent *pa);

};

#endif  // SKILLS_H
